cabal-version: 2.2

-- This file has been generated from package.yaml by hpack version 0.36.1.
--
-- see: https://github.com/sol/hpack

name:           spicy-blocksparse
version:        0.1.0
description:    Parallel block sparse matrices for Spicy
author:         Phillip Seeber, Sebastian Seidenath
maintainer:     phillip.seeber@uni-jena.de, sebastian.seidenath@uni-jena.de
copyright:      2024 Phillip Seeber, Sebastian Seidenath
license:        AGPL-3.0-only
license-file:   LICENSE
build-type:     Simple
extra-source-files:
    LICENSE
extra-doc-files:
    docs/images/rendered/blocksparse_matrix.svg

source-repository head
  type: git
  location: https://gitlab.com/theoretical-chemistry-jena/quantum-chemistry/Spicy

library
  exposed-modules:
      Spicy.Math.BlockSparse
  other-modules:
      Paths_spicy_blocksparse
  autogen-modules:
      Paths_spicy_blocksparse
  hs-source-dirs:
      src
  default-extensions:
      NoImplicitPrelude
      StrictData
      OverloadedStrings
      OverloadedLabels
      OverloadedRecordDot
      RecordWildCards
      CApiFFI
      DeriveGeneric
      DerivingVia
      DerivingStrategies
      DuplicateRecordFields
      GADTs
      LambdaCase
      QuantifiedConstraints
      TypeFamilies
      ViewPatterns
      DataKinds
  ghc-options: -Wall -Wcompat -Widentities -Wincomplete-record-updates -Wincomplete-uni-patterns -Wpartial-fields -Wredundant-constraints
  cc-options: -O3 -fopenmp
  include-dirs:
      c-src
  c-sources:
      c-src/demo.c
      c-src/MatMul.c
  extra-libraries:
      dbcsr_c
  build-depends:
      base >=4.16 && <4.21
    , derive-storable >=0.3.0.0 && <0.4
    , derive-storable-plugin >=0.2.3 && <0.3
    , massiv >=1.0.1.0 && <1.1
    , mpi-hs >=0.7.2 && <0.8
    , mpi-hs-binary >=0.1.1.0 && <0.2
    , mtl >=2.2.2 && <2.4
    , rio >=0.1.13.0 && <0.2
    , spicy-prelude >=0.1.0 && <0.2
  default-language: GHC2021

test-suite spicy-blocksparse-test
  type: exitcode-stdio-1.0
  main-is: test.hs
  other-modules:
      Spicy.MpiClient
      Spicy.Tests.Math.BlockSparse
      Paths_spicy_blocksparse
  autogen-modules:
      Paths_spicy_blocksparse
  hs-source-dirs:
      test
  default-extensions:
      NoImplicitPrelude
      StrictData
      OverloadedStrings
      OverloadedLabels
      OverloadedRecordDot
      RecordWildCards
      CApiFFI
      DeriveGeneric
      DerivingVia
      DerivingStrategies
      DuplicateRecordFields
      GADTs
      LambdaCase
      QuantifiedConstraints
      TypeFamilies
      ViewPatterns
      DataKinds
  ghc-options: -Wall -Wcompat -Widentities -Wincomplete-record-updates -Wincomplete-uni-patterns -Wpartial-fields -Wredundant-constraints -threaded -rtsopts -with-rtsopts=-N
  build-depends:
      base >=4.16 && <4.21
    , derive-storable >=0.3.0.0 && <0.4
    , derive-storable-plugin >=0.2.3 && <0.3
    , hedgehog >=1.0.5 && <1.6
    , massiv >=1.0.1.0 && <1.1
    , mpi-hs >=0.7.2 && <0.8
    , mpi-hs-binary >=0.1.1.0 && <0.2
    , mtl >=2.2.2 && <2.4
    , rio >=0.1.13.0 && <0.2
    , spicy-blocksparse
    , spicy-finitecompare >=0.1.0 && <0.2
    , spicy-linearalgebra >=0.1.0 && <0.2
    , spicy-prelude >=0.1.0 && <0.2
    , tasty >=1.2.3 && <1.6
    , tasty-hedgehog >=1.3.1.0 && <1.5
    , tasty-hunit >=0.10.0.2 && <0.11
  default-language: GHC2021
